var code = document.getElementById("err_succ");
var errs;
var vs, vc, is, ic;
var stamp = 0;
var dsets = [];
var lines_chart =  new Chart("lines", {
	type: "line",
	data : {
		datasets: dsets
	},
	options: {
		legend: {display: false},
		animation: { duration: 0 },
		scales: {
			xAxes: [{position:"top", type:"linear", ticks: {min: 0, max:78}}],
			yAxes: [{ticks: {reverse:true, min: 0, max:51}}]
		}
	}
});
		
function main()
{
	setInterval(next_graphs, 25);
}

function pixy_error_conversion(code)
{
	switch(code)
	{
		case 0:
			return code + "(SUCCESS)";
		case -1:
			return code + "(GENERAL ERROR)";
		case -2:
			return code + "(PIXY_ERROR)";
		case -3:
			return code + "(CHECKSUM ERROR)";
		case -4:
			return code + "(TIMEOUT ERROR)";
		case -100:
			return code + "(INVALID CODE)";
		default:
			return code + "(UNKNOWN CODE)";
	}
}

function next_graphs()
{	
	if(!pcm.ReadUIntArray("FM_vs", 240, 1))
	{
		code.innerText = "FM ERROR: " + pcm.LastRetMsg;
		dsets.length = 0;
		return;
	}
	
	vs = pcm.LastMemory_data.toArray();

	if(!pcm.ReadVariable("vc"))
	{
		code.innerText = "FM ERROR: " + pcm.LastRetMsg;
		dsets.length = 0;
		return;
	}
	
	vc = pcm.LastVariable_vValue;
	
	if(!pcm.ReadUIntArray("FM_is", 252, 1))
	{
		code.innerText = "FM ERROR: " + pcm.LastRetMsg;
		dsets.length = 0;
		return;
	}
	
	is = new Uint8Array(pcm.LastMemory_data.toArray());

	if(!pcm.ReadVariable("ic"))
	{
		code.innerText = "FM ERROR: " + pcm.LastRetMsg;
		dsets.length = 0;
		return;
	}
	
	ic = pcm.LastVariable_vValue;
	
	if(!pcm.readDoubleArray("FM_errors", 4))
	{
		code.innerText = "FM ERROR: " + pcm.LastRetMsg;
		dsets.length = 0;
		return;
	}
	
	errs = pcm.LastMemory_data.toArray();
	
	code.innerText ="\nBOARD COMMUNICATION OPEN!" + "\n\nPIXY INIT CODES:\n   " +
		pixy_error_conversion(errs[0]) + "\n   " +
		pixy_error_conversion(errs[1]) + "\n   " +
		pixy_error_conversion(errs[2]) + "\n\n" +
		"PIXY FEATURES CODE: " + pixy_error_conversion(errs[3]);
	
	dsets.length = 0;
	write_vs();
	write_is();
	lines_chart.update();
}
			
function write_vs()
{		
	for (v_idx = 0; v_idx < vc; v_idx++)
		dsets.push({data: [
			{
				x:vs[v_idx * 6],
				y:vs[v_idx * 6 + 1]
			},
			{
				x:vs[v_idx * 6 + 2],
				y:vs[v_idx *6 + 3]
			}],
			fill:false,
		});	
}

function write_is()
{
	for(i_idx = 0; i_idx < ic; i_idx++)
	{
		offset = i_idx * 28;
		line_count = is[offset + 2];
		
		for(l_idx = 0; l_idx < line_count; l_idx++)
		{
			line_offset = (l_idx + 1) * 4;
			angle = (new DataView(is.buffer, offset + line_offset + 2, 2)).getInt16(0, true) * Math.PI / 180;
			dsets.push({data: [
				{
					x:is[offset + 0],
					y:is[offset + 1]
				},
				{
					x:is[offset + 0] - 2 * Math.sin(angle),
					y:is[offset + 1] - 2 * Math.cos(angle)
				}],
				fill:false,
				borderColor: "red"
			})
		}
	}
}